.nolist
#define    TASM
#include   "app.inc"
defpage(0,"LangZ80")
#include   "langZ80\LangZ80.inc"
#define		bcall(xx)	rst 28h \ .dw xx
.list

; I am using hacked GDB# 13 to store the variables and such, so make sure it exists in RAM
	ld a,80h
	out (16),a
	ld hl,0D61h
	ld (OP1+1),hl
	call FindSym
	jr nc,FileVarExists
; create GDB 13 since it doesn't exist
	ld hl,6
	bcall(_CreateGDB)
	inc de
	inc de
	ld h,d
	ld l,e
	inc de
	dec c
	ld (hl),b
	ldir
	jr $+9
FileVarExists:
	ld a,b
	or a
	jr z,$+5
	bcall(_ArcUnarc)
	ld hl,tempname
	rst 20h
	call ExecProg
	bcall(4027h)

ExecProg:
	ld (sp_restore),sp
	call ChkFindVar
	ret c
	ld a,b
	or a
	ret nz
	ex de,hl
	ld c,(hl)
	inc hl
	ld b,(hl)
	inc hl
	ld a,b
	or c
	ret z
	ld (parseStart),hl
	ld (parseSize),bc
	ld (parsePtr),hl


; I am using hacked GDB# 13 to store the variables and such, so make sure it exists in RAM
	ld hl,0D61h
	ld (OP1+1),hl
	call FindSym
	ret c
	ld a,b
	or a
	ret nz
	ex de,hl
	ld c,(hl)
	inc hl
	ld b,(hl)
	inc hl
	ld (FileVarStart),hl
	ld (FileVarSize),bc
	ld c,(hl)
	inc hl
	ld b,(hl)
	inc hl
;bc is number of items on AnsStack
	ld a,b
	or c
	jr z,$+13
locateLUTLoop:
	push bc
	call GetTotalSize
	add hl,bc
	pop bc
	dec bc
	ld a,b
	or c
	jr nz,locateLUTLoop

	ld (AddrStck),hl
	ld c,(hl)
	inc hl
	ld b,(hl)
	inc hl
	add hl,bc
	ld (FileVarLUT),hl

	call ParseFile
	jp ReturnAns
ParseLoop:
	ld (parseSize),bc
	ld (parsePtr),hl
	ld a,(hl) \ cp 4   \ jp z,StoVar
;	call PopStckScratch
ParseFile:
	ld bc,(parseSize)
	ld hl,(parsePtr)
	call ParseArg
	ld a,b \ or c \ ret z
	call Is_End
	jr nz,ParseLoop
	cpi \ jp pe,$-7 \ ret	
ParseArg:
	ld (parsePtr),hl
	ld (parseSize),bc
	call Is_End
	jr nz,$+8
	cpi \ ret po \ jp ParseArg
	call ParseNext
	ld bc,(parseSize)
	ld hl,(parsePtr)
	ld a,b \ or c \ ret z
	ld a,29h
	cpi \ ret po \ jr z,$-3
	dec hl \ inc bc
	call Is_End
	ret z
	cp 4 \ ret z
	jp ParseArg
Is_End:
	ld a,(hl)
	cp 07h \ ret z	;]
	cp 09h \ ret z	;}
	cp 2Bh \ ret z	;,
	cp 3Eh \ ret z	;:
	cp 3Fh \ ret z	;NEWLINE
	cp 11h \ ret z	;)
	or a
	ret
ParseNext:
; Check if the byte is a number/decimal or not.
	cp 2Ah
	jp z,StoString
	cp $AE
	jp z,StoString
	cp 4
	jp z,StoVar
	cp 82h		;"*"
	jp z,implicitMul
	cp 30h
	jr c,$+7
	cp 3Bh
	jp c,StoNum
; If we get here, the command is either a function name, a variable name, or invalid.
; Check functions first
	ld hl,functionLUT
	call BinSearch
	jr nz,$+12 \ inc hl \ ld (parsePtr),de \ ld (parsesize),bc \ jp (hl)
	ld hl,(FileVarLUT)
;	push hl
	call BinSearch
;	pop de
	jp nz,err_invalid
HandleVar:
; Check:
; If it is a list,array, or string, do we read specific elements, or the whole thing?
	ld a,(de)
	inc hl
	push hl
	ld hl,(parsePtr)
	ld (parsePtr),de
	ld (parseSize),bc
	or a
	ex de,hl
	sbc hl,de
	ld b,h
	ld c,l
	pop hl
	cp 6		;"["
	jr z,readvarelem
	push hl
	push bc
	call GetTotalSize
	ld a,b \ or c \ ret z
	push hl
	ld hl,scratch_size
	or a
	sbc hl,bc
	pop hl
	ld de,scratch
	jr c,$+7
	pop af \ pop af \ ldir \ ret
	ex de,hl
	pop bc
	ld (hl),type_indirect
	inc hl
	ld (hl),c
	inc hl
	ld (hl),b
	inc hl
	pop de
	ex de,hl
	ldir
	xor a
	ld (de),a
	ret
readvarelem:
	ld a,(hl)
	sub 2		;string
	jr z,extractelement
	dec a		;list
	jr z,extractelement
	dec a		;array
	jp nz,implicitMul
extractelement:
	call PushPtr
	call Parse
	call ScratchToInt
	push de
	ld hl,(parsePtr)
	ld de,1
	ld a,(hl)
	cp 3Eh
	jr nz,$+19
		ld hl,$0200
		ld (scratch),hl
		ld h,l \ dec hl
		ld (scratch+2),hl
		call Parse
		call ScratchToInt
	push de
	call PopPtr
	ld a,(hl)
	pop bc
	pop de
;HL points to the var data start
;DE is the element number to start reading at
;BC is the number of elements to read
	or a		;for later use
	push af
	call GetElemRange
;bc=size, de=#elements, hl=addr
	pop af
	push de
	push af
	ex de,hl
	ld hl,scratch_size-3
	or a
	sbc hl,bc
	ex de,hl
	ld de,scratch
;bc is size
;hl is addr
	jr nc,_0
	call PushPtr
	push bc
	inc bc
	inc bc
	inc bc
	call InsAnsStck
	ex de,hl
	call PopPtr
	pop bc
	pop af
	scf
	jr $+3
_0:
;DE is where to write
;BC is number of bytes
;HL is where the data is
	pop af
	ex de,hl
	ld (hl),a
	inc hl
	ex de,hl
	ex (sp),hl
	ex de,hl
	ld (hl),e
	inc hl
	ld (hl),d
	inc hl
	pop de
	ex de,hl
	push af
	ld a,b
	or c
;	jp z,PopStckScratch	;If the size is 0, it is already written to scratch
	jp z,Pop1Exit
	ldir
	pop af
	ret nc
	jp PopStckScratch
StoString:
	ld e,a
	cpi
	push hl
	jp po,StringEnd
stringreadloop:
	ld a,(hl)
	cp e \ jr z,StringEnd-2
	cp 04h \ jr z,StringEnd
	cp 3Fh \ jr z,StringEnd
	cpi
	jp pe,stringreadloop
	inc bc
	cpi
StringEnd:
	ld (parsePtr),hl
	ld (parseSize),bc
	pop de
	cp e \ push af
	or a
	sbc hl,de
	ex de,hl
	ld b,d
	ld c,e
	ld de,scratch
	ex de,hl
	ld (hl),type_string
	inc hl
	ld (hl),c
	inc hl
	ld (hl),b
	inc hl
	ex de,hl
	ld a,b \ or c \ jr z,$+4
	ldir
	pop af
	ret nz
	
	ret
InsAnsStck:
	ld hl,(AnsStack)
	ld e,(hl)
	inc hl
	ld d,(hl)
	inc de
	ld (hl),d
	dec hl
	ld (hl),e
	inc hl
	inc hl
	jp AllocateRAM
StoNum:
;First, we need to convert the number to an integer (or float if there is a decimal).
;Then the result is pushed onto the AnsStack
	ld de,0
	ld (convscratch),de	;basically says it is an int of 0 bytes 
StoNumLoop:
	ld a,(hl)
	sub 3Ah
	jp z,StoFloat
	add a,10
	jr nc,StoInt
	call stonumsub
	cpi
	jp pe,StoNumLoop
StoInt:
	ld (parsePtr),hl
	ld (parseSize),bc
	ret
	
StoVar:
;need to look for the var
;if it exists, replace it
;if not, create it.
	ld hl,(parsePtr)
	ld bc,(parseSize)
	cpi
	jp po,err_badname
	ld (parseSize),bc
	ld (parsePtr),hl
	ld hl,(FileVarLUT)
	call BinSearch
	jp z,varalreadyexists
;If HL=SearchSize...
;  Data gets appended to the var
	ld de,(SearchSize)
	or a
	sbc hl,de
	add hl,de
	jr nz,jp00
	  add hl,hl
	  ld de,(base)
	  add hl,de
	  push hl
	  ld bc,(FileVarSize)
	  ld hl,(FileVarStart)
	  add hl,bc
	  ld b,h
	  ld c,l
	  sbc hl,de
;	inc hl
;	inc hl
	  ex (sp),hl
;	  inc hl
;	  inc hl
	  inc hl
	  push hl
	  push bc
	  jr jp01
jp00:
	add hl,hl
	ld de,(base)
	add hl,de
	ld c,(hl) \ inc hl \ ld b,(hl) \ push bc \ push hl
	ex de,hl \ add hl,bc
	push hl
jp01:
	ld bc,(parseSize)
	ld hl,(parsePtr)
;	cpi
;	jp po,err_badname
	call GetAlphaNumericSize
	ld a,d \ or e \ jp z,err_badname
	push de
	ld (parsePtr),hl \ ld (parseSize),bc
	ld hl,scratch \ call GetTotalSize
	pop hl \ ld d,h \ ld e,l \ add hl,bc \ inc hl
	exx \ pop hl \ exx \ push bc \ push de
	exx \ push hl \ exx
	inc hl
	inc hl
	bcall(_EnoughMem)
	jp c,err_mem
	pop hl
	ld b,d
	ld c,e
	dec bc \ dec bc
	call AllocateRAM
	pop bc
	ex de,hl
	ld hl,(parsePtr)
	or a
	sbc hl,bc
	ldir
	xor a \ ld (de),a
	inc de
	pop bc \ ld hl,scratch
	ldir
	pop hl
	dec hl
	ld c,2
	call AllocateRAM
	pop bc
		inc bc
		inc bc
	ld (hl),c
	inc hl
	ld (hl),b
	ld hl,(FileVarLUT)
	inc (hl) \ jr nz,$+4
	inc hl \ inc (hl)
	ld bc,(parseSize)
	ld hl,(parsePtr)
	ret
StoFloat:
;HL points to the decimal point
;BC is the number of bytes left in the file
;Need to default to 128-bits
;format is:
;  .db type_float
;  .db xx	;size of integer part (basically, decimal location). Signed.
;  .db yy	;total size of data. Default=16 (16 bytes = 128 bits)
;  .db data
;Currently, (scratch) contains the integer part.
;  If >128 bits, add 32 more bits of decimal point precision and call it a day.
;  If <128 bits, make it 128 bits, rotating in new bits
;Before all this, convert to BCD, use mad DAA tricks
;Aww, yiss.
	exx
	ld hl,scratch2-1
	ld bc,0
	exx
;remember to enforce the 510 digit cap
	cpi
	jp po,nomofloating
str2bcdloop:	
	ld a,(hl)
	sub 3Ah
	add a,10
	exx
	inc b
	jr nc,nomofloating
	bit 0,b \ jr z,$+4 \ inc hl \ inc c
	rld	;is this right? or is it rrd?
	exx
	cpi
	jp pe,str2bcdloop
	exx
	inc b
nomofloating:
	bit 0,b
	jr nz,$+5
	xor a \ rld
	exx
	ld (parsePtr),hl
	ld (parseSize),bc
;now C' is the size of the BCD number in bytes (up to 255 bytes, or well, 510 digits, I hope)
;scracth2 has the BCD number in a normal kind of little endian
;WARNING! No code is put in place to enforce the 510 digit cap


;next up, convert the integer to float
;Actually, this should be a sub routine
	ld bc,(scratch)	;size of the integer
;b is the size of the integer part
	ld a,floathalfsize
	cp b
	jr nc,$+4
	add a,floathalfsize
	add a,floathalfsize
	ld c,a
;B is the size of the integer part
;A,C is the total size
	ld hl,scratch
	call IntToFloat
frac2floatloop0:
	ld b,8
frac2floatloop1:
	exx
	call DoubleBCD
	exx
	rl (hl)
	djnz frac2floatloop1
	dec hl
	dec c
	jr nz,frac2floatloop0
	ret
;seems legit, next part:
IntToFloat:
;need to start HL at HL+B+1
;Need DE at HL+C+2
	ld a,c
	sub b
	push bc
	ld c,b
	ld b,0
	inc hl
	add hl,bc
	push bc
	ld d,h
	ld e,l
	ld c,a
	inc bc
	add hl,bc
	ex de,hl
	pop bc
	lddr
	ld b,a
;number of bytes to delete
	ld h,d
	ld l,e
	ld (hl),c \ dec hl \ djnz $-2
	pop bc
	ld (hl),c
	dec hl
	dec hl
	ld (hl),1
	ld c,a
	ex de,hl
	ret
;seems legit, next part
DoubleBCD:
;C is number of bytes
;HL location
;Output:
;  HL,C are preserved
;  Returns c if overflow, else nc
	push hl
	or a
	ld b,c
BCD_mul_2_loop:
	ld a,(hl)
	adc a,a
	daa
	ld (hl),a
	dec hl
	djnz BCD_mul_2_loop
	pop hl
	ret
varalreadyexists:
;just resize the var, load new data
;Use Allocate
;so basically, allocate oldsize-newsize at the var data position
	ld (parsePtr),de
	ld (parseSize),bc
	inc hl
	push hl
	ld hl,scratch
	call GetTotalSize
;now find the location of the next var
	ld de,(curelement)
	ld hl,(searchsize)
	scf
	sbc hl,de
	jr nz,$+12
		ld hl,(FileVarStart)
		ld de,(FileVarSize)
		add hl,de
		jr _
	inc de
	ex de,hl
	add hl,hl
	ld de,(base)
	add hl,de
	ld a,(hl)
	inc hl
	ld h,(hl)
	ld l,a
	add hl,de
_:
	pop de
	sbc hl,de
;DE is where to insert data
;HL is the size of current data
;BC is the size of the new data
	push bc
	sbc hl,bc
	ld b,h
	ld c,l
	ex de,hl
	call DeAllocateRAM
	ex de,hl
	ld hl,scratch
	pop bc
	ld a,b \ or c \ jr z,$+4
	ldir
	ld bc,(parseSize)
	ld hl,(parsePtr)
	ret	
OnPause:
	in a,(4) \ and 8 \ jr nz,$-4
	jp error

ReturnAns:
	call ConvScratchToStr
ReturnStr:
	push hl
	push bc
	bcall(_Ansname)
	call FindSym
	bcall(_DelVarNoArc)
	pop hl
	bcall(_CreateStr)
	inc de
	inc de
	pop hl
	ld a,b \ or c \ ret z
	ldir
	ret



#include "LangZ80\functions.txt"




Parse:
	call IncPtr
	jp ParseArg
IncPtr:
	ld hl,(parsePtr)
	ld bc,(parseSize)
	ld a,b \ or c
	ret z
	cpi
	ld (parsePtr),hl
	ld (parseSize),bc
	ret

StackToInt:
	ld hl,(AnsStack)
	ld e,(hl)
	inc hl
	ld d,(hl)
	inc hl
	ld a,d
	or e
	ret z
	call PopStck
ScratchToInt:
	ld de,0
	ld hl,scratch
	ld a,(hl)
	or a
	jr nz,ToInt
	inc hl
	ld a,(hl)
	or a
	ret z
	inc hl
	ld e,(hl)
	dec a
	ld a,e
	ret z
	inc hl
	ld d,(hl)
	ret
ToInt:
	dec a
	jr z,$+8
	  set err,(iy+asmflags2)
	  ld a,e
	  ret
	inc (hl)
	ld c,(hl)
	ld b,a
	inc hl
	ld e,(hl)
	ld d,a
	inc hl
	add hl,de
	sbc hl,bc
;Now HL points to the lower byte of the integer part of the float
	or c
	ld e,d
	ret z
	ld e,(hl)
	dec c
	ret z
	inc hl
	ld d,(hl)
	ret
ConvScratchToStr:
;returns HL as the pointer to the string, BC as the size. 
	ld de,scratch+513
	xor a
	ld (de),a
	ld hl,scratch
	ld a,(hl)
	or a
	jr nz,ToStr1
;convert the int to a string
	exx
	ld bc,(scratch+1)
	ld b,a
;bc is the number of bytes
	ld hl,scratch+1
	add hl,bc
	ld (tempword1),hl
	ld a,c
	ld c,10
	exx
	or a
	jr nz,inttodecloop-1
		dec de
		ld a,30h
		ld (de),a
		ex de,hl
		ld bc,1
		ret

	ld c,a
inttodecloop:
	ld a,c
	exx
	ld b,a
	ld hl,(tempword1)
	ld a,(hl) \ dec hl \ or a \ jr nz,$+6 \ djnz $-5 \ jr IntisStr
	ld hl,(tempword1)
	exx
	dec de
	ld b,c
	xor a
scratch_div_10:
	exx
	ld b,8
	ld d,(hl)
	sla d \ rla \ cp c \ jr c,$+4 \ inc d \ sub c \ djnz $-8
	ld (hl),d \ dec hl
	exx
	djnz scratch_div_10
	add a,30h
	ld (de),a
	jp inttodecloop
IntIsStr:
	exx
	ld hl,scratch+513
	sbc hl,de
	ld b,h
	ld c,l
	ex de,hl
	ret
ToStr1:
	ld b,a
	dec b
	jp nz,stringToString
;First convert the integer part to a string
;Then convert fractional part

	exx
	ld bc,(scratch+1)
	ld a,b
	ld b,0
	sub c
;bc is the number of bytes in the integer part
;a is the number of bytes in the fractional part
	ld hl,scratch+2
	add hl,bc
	push bc
	ld c,a
	add hl,bc
	ld (tempword1),hl
	pop bc
	push af
	ld a,c
	ld c,10
	exx
	or a
	jr nz,$+12
		dec de
		ld a,30h
		ld (de),a
		ex de,hl
		ld bc,1
		pop af
		ret
	call IntToDecLoop-1
;now copy the string back to the start of scratch2.
;Keep track of the tail
;Place a decimal point
	ld de,scratch2
	or a
	sbc hl,de
	jr nc,skdufg2315
	ld d,h
	ld e,l
	dec de
	dec de
	dec de
	push bc
	push de
	ldir
	ex de,hl
	ld (hl),$3A	;decimal point
	inc hl
	ld (hl),$BB	;copy "..." 2-byte token 
	inc hl
	ld (hl),$DB
	pop hl
	pop bc
	pop af
	ret
skdufg2315:
;HL is negative max size left, -1
	push hl
	add hl,de
	ld a,b \ or c \ jr z,$+4
	ldir
	ld a,$3A
	ld (de),a	;decimal point
	inc de
;DE needs to be kept and then stored to HL before "exx"
	ld hl,(scratch+1)
	ld a,h
	sub l
	call A_times_log256
	ex de,hl
	ex (sp),hl
	or a
	sbc hl,de
	add hl,de
	jr nc,$+3
	ex de,hl	;now DE is the smaller of the two numbers
	pop hl
	ld b,d
	ld c,e
	exx

	pop bc
	ld de,scratch+3
;b are the size of the fractional part
;de points to the fractional part

;Multiply decimal part by 10, take overflow as next digit
	inc b
	dec b
	jr z,endfloat2str
flt2strloop2:
	call Frac_Times_10	;return overflow in A, B is adjusted size, DE is adjusted ptr
	inc b
	dec b
	jr z,endfloat2str
	exx
	add a,30h
	ld (hl),a
	cpi
	exx
	jp pe,flt2strloop2
endfloat2str:
;now we round
	exx	
	dec hl
	ld (hl),a
	sub 30h
	cp 5
	push hl
	jr c,fixfloatstr
rndstrloop:
	dec hl \ ld a,(hl) \ inc a \ ld (hl),a
	cp 3Bh
	jr nz,$+7
	  ld (hl),0
	  dec hl
	  jr rndstrloop
	cp 3Ah
	jr nz,fixfloatstr
	ld (hl),30h
	jp rndstrloop
fixfloatstr:
	pop hl
	ld a,30h
	dec hl \ cp (hl) \ jr z,$-2
	ld a,(hl) \ or a
	jr z,$+3
	inc hl
	ld de,scratch2
	or a
	sbc hl,de
	ld b,h
	ld c,l
	ex de,hl
	ret
Frac_times_10:
	xor a \ or b \ ret z \ xor a \ ex de,hl \ ld d,a
	or (hl) \ jr nz,$+7 \ inc hl \ djnz $-4 \ ex de,hl \ ret
	push hl
	push bc
	ld e,d
times_10_loop:
	ld c,e
	ld a,(hl)
	add a,a \ rl c
	add a,a \ rl c
	add a,(hl) \ jr nc,$+3 \ inc c
	add a,a \ rl c
	add a,d \ jr nc,$+3 \ inc c
	ld d,c
	ld (hl),a
	inc hl
	djnz times_10_loop
	ld a,d
	pop bc
	pop de
	ret
stringToString:
	djnz listToString
	inc hl
	ld c,(hl)
	inc hl
	ld b,(hl)
	inc hl
	ret
listToString:
	ret
LoadScratchDud:
	ld hl,0
	ld (scratch),hl
	ret
PushAnsScratch:
	ld hl,scratch
PushAns:
; First, allocate RAM, but keep track of ptrs
; insert before the LUT in the GDB var
; This way you don't need to update the whole LUT
; Still need to update the size of the GDB var
; Need to update the location of the LUT
;Inputs: HL points to the variable data
	call PushPtr
	call GetTotalSize
	ld a,b \ or c \ ret z
	ld hl,(AnsStack)
	inc hl
	inc hl
	call AllocateRAM
	call PopPtr
	ex de,hl
	ld hl,(AnsStack)
	inc (hl) \ inc hl
	jr nz,$+3 \ inc (hl) \ inc hl
	ex de,hl
	ldir
	ret
RemoveAnsStack:
	res savestck,(iy+asmflags2)
	ld a,b \ or c \ ret z
	push bc
	call PopStck
	pop bc
	dec bc
	ld a,b
	or c
	jr nz,$-8
	ret
PopStckScratch:
	set savestck,(iy+asmflags2)
PopStck:
	ld hl,(AnsStack)
	ld c,(hl)
	inc hl
	ld b,(hl)
	ld a,b \ or c
	jp z,LoadScratchDud
	dec bc
	ld (hl),b
	dec hl
	ld (hl),c
	inc hl
	inc hl
	call GetTotalSize
	ld a,b \ or c \ ret z	;I have no idea when this could ever be relevant, but it is a precaution.
	bit savestck,(iy+asmflags2)
	jr z,DeallocateRAM
	ld de,scratch
	push hl
	push bc
	ldir
	pop bc
	pop hl
DeallocateRAM:
	xor a \ sub c \ ld c,a
	sbc a,a \ sub b \ ld b,a
AllocateRAM:
;  HL points to where to allocate RAM
;  BC is the number of bytes to allocate (if negative, deallocate)
;Output:
;  HL,BC preserved
;Notes:
;  Check if BC is non-zero
;  Check if HL is inside the GDB var
;  Check if enough RAM
;  InsertMem
;  Update the size of the GDB
;  Update ptrs. Examples: FileVarLUT, parseStart, parsePtr

	ld a,b \ or c \ ret z
	ld de,(FileVarStart)
	sbc hl,de
	jp c,err_alloc
	ld de,(FileVarSize)
	sbc hl,de
	add hl,de
	jr z,$+5
	jp nc,err_alloc
	ld de,(FileVarStart)
	add hl,de
;check if BC is positive or negative
	bit 7,b
	jr nz,delmem
	push hl
	ld h,b
	ld l,c
	bcall(_EnoughMem)
	jp c,err_mem
	pop hl
	ld b,d
	ld c,e
	push hl
	push bc
	ex de,hl
	bcall(_InsertMem)
	jp updatesize
delmem:
	push hl
	push bc
	xor a \ sub c \ ld e,a
	sbc a,a \ sub b \ ld d,a
	bcall(_DelMem)
updatesize:
	pop bc
	ld hl,(FileVarStart)
	dec hl
	ld d,(hl)
	dec hl
	ld e,(hl)
	ex de,hl
	add hl,bc
	ex de,hl
	ld (hl),e
	inc hl
	ld (hl),d
	ld (FileVarSize),de
	pop hl
UpdatePtrs:
	ex de,hl
	UPDPTR(FileVarLUT)
	UPDPTR(AddrStck)
	UPDPTR(parseStart)
	UPDPTR(parsePtr)
	UPDPTR(tempAddr1)
	UPDPTR(tempAddr2)
	UPDPTR(tempAddr3)
	UPDPTR(tempAddr4)
	UPDPTR(tempAddr5)
	UPDPTR(pushaddrtemp)
AddrPtrUpd:
	exx
	ld hl,(AddrStck)
	ld c,(hl)
	inc hl
	ld b,(hl)
	inc hl
	ld a,b
	or c
	jr z,lutptrupdate
AddrPtrUpdLoop:
	ld e,(hl) \ inc hl
	ld d,(hl)
	push de
	exx
	pop hl
	or a \ sbc hl,de \ add hl,de \ jr c,$+3 \ add hl,bc
	push hl
	exx
	pop de
	ld (hl),d \ dec hl
	ld (hl),e
	inc hl
	cpi
	jp pe,AddrPtrUpdLoop
lutptrupdate:
	exx
	ld hl,(FileVarLUT)
	inc hl
	inc hl
	ex de,hl
	or a
	sbc hl,de
	ex de,hl
	add hl,de
	ret c
	ret z
	push hl
	push bc
;DE is how far after the LUT the insertion occured
	exx
	ld hl,(FileVarLUT)
	ld c,(hl)
	inc hl
	ld b,(hl)
	inc hl
	ld a,b
	or c
	jr z,exit_lutptr
lutptrupdateloop:
	ld a,(hl) \ inc hl \ ex af,af' \ ld a,(hl)
	exx
	ld h,a \ ex af,af' \ ld l,a
	or a \ sbc hl,de \ add hl,de \ jr c,$+3 \ add hl,bc
	ld a,l \ ex af,af' \ ld a,h
	exx
	ld (hl),a \ dec hl \ ex af,af' \ ld (hl),a \ inc hl
	cpi
	jp pe,lutptrupdateloop
exit_lutptr:
	pop bc
	pop hl
	ret
PushPtr:
	ld (pushaddrtemp),hl
	ld hl,(AddrStck)
	inc (hl)
	inc hl
	jr nz,$+3 \ inc (hl)
	inc hl
	ld bc,2
	call AllocateRAM
	ld de,(pushaddrtemp)
	ld (hl),e
	inc hl
	ld (hl),d
	ex de,hl
	ret
PopPtr:
	push af
	push bc
	push de
	ld hl,(AddrStck)
	ld c,(hl)
	inc hl
	ld b,(hl)
	dec bc
	ld (hl),b
	dec hl
	ld (hl),c
	inc hl
	inc hl
	ld e,(hl)
	inc hl
	ld d,(hl)
	dec hl
	ld (pushaddrtemp),de
	ld bc,2
	call DeallocateRAM
	ld hl,(pushaddrtemp)
	pop de
	pop bc
	pop af
	ret
GetElemRange:
;Inputs:
;  HL=var data start
;  DE=element start
;  BC=number of elements to read
;Outputs:
;  HL=Address
;  BC=Size
	ld a,(hl)	;will be 2,3,4
	inc hl
	sub 2
	jr nz,GERList
	push bc
	ld c,(hl)
	inc hl
	ld b,(hl)
	inc hl
	ex de,hl
	sbc hl,bc
	jr c,$+9
	pop bc \ ld bc,0 \ ld d,b \ ld e,c \ ret
	ex de,hl
;DE=ElemStart-varsize
;HL=vardata
;BC=varsize
	add hl,de
	add hl,bc
	pop bc
	ex de,hl
	add hl,bc
	ex de,hl
	jr nc,$+11
;BC-DE->BC
	push hl
	ld h,b
	ld l,c
	or a
	sbc hl,de
	ld b,h
	ld c,l
	pop hl
	ld d,b
	ld e,c
	ret
GERList:
	dec a
	jr nz,GERArray
	ret
GERArray:
	ret

GetTotalSize:
;Input: HL points to the var
;Output: HL is not changed, BC is the size of the var
	ld a,(hl)
	or a
	inc hl
	jr nz,size1
	ld c,(hl)
	ld b,0
	inc bc
	inc bc
	dec hl
	ret
size1:
	ld b,a
	djnz GetSizeStr
;float
	inc hl
	ld c,(hl)
	inc bc
	inc bc
	inc bc
	dec hl
	dec hl
	ret
GetSizeStr:
	djnz GetSizeList
	ld c,(hl)
	inc hl
	ld b,(hl)
	inc bc
	inc bc
	inc bc
	dec hl
	dec hl
	ret
GetSizeList
	ret

stonumsub:
	exx
	ex af,af'
	ld a,(convscratch+1)
	or a \ jr nz,$+12
	  inc a \ ld (convscratch+1),a
	  ex af,af'
	  exx
	  ld (convscratch+2),a
	  ret
	ld c,a

	ld hl,convscratch+258
	ld de,convscratch+2
	ld b,c
	ld a,(de) \ rla \ ld (hl),a
	inc de \ inc hl \ djnz $-5
	call c,incInt

	ld hl,convscratch+258
	ld b,c
	rl (hl) \ inc hl \ djnz $-3
	call c,incInt

	ld hl,convscratch+258
	ld de,convscratch+2
	ld b,c
	ld a,(de) \ adc a,(hl) \ ld (hl),a
	inc de \ inc hl \ djnz $-5
	call c,incInt

	ld hl,convscratch+258
	ld b,c
	rl (hl) \ inc hl \ djnz $-3
	call c,incInt

	ld hl,convscratch+258
	ld d,b
	ld b,c
	ex af,af'
	add a,(hl) \ ld (hl),a \ jr nc,endmul10
	dec b \ jr z,$+8
	inc hl \ inc (hl) \ jr nz,endmul10 \ djnz $-4
	call incInt
endmul10:
	ld a,c
	ld (convscratch+1),a
	ld de,convscratch+2
	ld hl,convscratch+258
	ld b,0
	ldir
	exx
	ret
IncInt:
	inc c
	jp z,err_overflow
	ld (hl),1
	xor a \ ld (de),a
	ret
#include "LangZ80\Routines.txt"
#include "LangZ80\Errors.txt"
.echo "Total Code Size:",$-4080h
validate()