;  GDB Format:
;	xx bytes number of items on the AnsStack
;	  n bytes for the items
;	yy number of items on the AddrStck
;	  2*yy bytes of addresses
;	zz size of the variable LUT
;	  2*zz bytes of offsets
;	  n bytes for the variable data

#define UPDPTR(xx)	ld hl,(xx) \ or a \ sbc hl,de \ add hl,de \ jr c,$+3 \ add hl,bc \ ld (xx),hl
#define addfunc(xx)	.dw xx-functionLUT-2

OP1		= 8478h
OP2		= 8483h
_CreateGDB	= 4336h
_ArcUnarc	= 4FD8h
_RclAns		= 4AD7h
_EnoughMem	= 42FDh
_InsertMem	= 42F7h
_DelMem		= 4357h
_DelVarNoArc	= 4FC9h
_CreateStr	= 4327h
_AnsName	= 4B52h
saveSScreen	= 86ECh
gbuf		= 9340h
FileVarStart	= saveSScreen		;Pointer to the start of the GDB. Also AnsStack.
FileVarLUT	= saveSScreen+2		;Pointer to the variable index.
FileVarSize	= saveSScreen+4		;Size of the GDB.c
parseStart	= saveSScreen+6		;Pointer to the start of the file being parsed
parseSize	= saveSScreen+8		;The size of the file being parsed
parsePtr	= saveSScreen+10	;Pointer to the current parsing address
base		= saveSScreen+12	;Used in the BinSearch. This is the base of the LUT from which it's addresses are relative.
searchsize	= saveSScreen+14	;Number of items in the LUT
curelement	= saveSScreen+16	;Current element number being checked
curdelta	= saveSScreen+18	;How much to add/sub to curelement
tempword1	= saveSScreen+20	;
tempword2	= saveSScreen+22	;
tempword3	= saveSScreen+24	;
tempword4	= saveSScreen+26	;
tempword5	= saveSScreen+28	;
AddrStck	= saveSScreen+30	;pointer to an array of addresses that gets updated when data is inserted or removed to get updated as needed
tempaddr1	= saveSScreen+32	;
tempaddr2	= saveSScreen+34	;
tempaddr3	= saveSScreen+36	;
tempaddr4	= saveSScreen+38	;
tempaddr5	= saveSScreen+40	;
pushaddrtemp	= saveSScreen+42	;when pushing an address to the address stack, save it here sp_restore	= saveSScreen+44	;in case of emergency, use this to exit the app 
sp_restore	= saveSScreen+44	;
convscratch	= saveSScreen+254	;514 bytes for scracth work, like math
scritch		= 9872h

AnsStack	= FileVarStart
scratch		= convscratch
scratch2	= convscratch+257
floathalfsize	= 8
scratch_size	= 89ECh-scratch

asmflags1	= 33
asmflags2	= 34
savestck	 =0	;when popping to the stack, do we copy to Scratch first?
err		 =1	; is there an error?

asmflags3	= 35

type_int	= 0	;.db 0 \ .db #bytes,data
type_float	= 1	;.db 1 \ .db ipartsize,fpartsize,data
type_string	= 2	;.db 2 \ .dw size \ .db data
type_list	= 3	;.db 3 \ .dw #elements \ .db data
type_array	= 4	;.db 4 \ .db dimensions,dim1,dim2,...,datasize,data
type_sprite	= 5	;.db 5 \ .dw width,height \ .db data
type_indirect	= 20h	;.db 20h \ .db varname,0